﻿// Solution created by Boyan Mihaylov
// http://code.dortikum.net

using System;
using System.ComponentModel.Composition;

namespace BoyanMihaylov.Solution
{
	public interface IExport
	{
		/// <summary>
		/// Registers a type as an import.
		/// </summary>
		/// <param name="type">The type.</param>
		void As(Type type);


		/// <summary>
		/// Registers the same export type as an import.
		/// </summary>
		void AsSelf();


		/// <summary>
		/// Sets the creation policy of an export.
		/// </summary>
		/// <param name="policy">The policy.</param>
		/// <returns></returns>
		IExport WithPolicy(CreationPolicy policy);
	}
}
